/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2018 Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.ASTQ = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(_dereq_,module,exports){
(function (global){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).ASTY=e()}}(function(){return function(){return function e(n,t,r){function i(u,a){if(!t[u]){if(!n[u]){var f="function"==typeof _dereq_&&_dereq_;if(!a&&f)return f(u,!0);if(o)return o(u,!0);var l=new Error("Cannot find module '"+u+"'");throw l.code="MODULE_NOT_FOUND",l}var c=t[u]={exports:{}};n[u][0].call(c.exports,function(e){return i(n[u][1][e]||e)},c,c.exports,e,n,t,r)}return t[u].exports}for(var o="function"==typeof _dereq_&&_dereq_,u=0;u<r.length;u++)i(r[u]);return i}}()({1:[function(e,n,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},i=function(){function e(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(n,t,r){return t&&e(n.prototype,t),r&&e(n,r),n}}();var o=function(){function e(){!function(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}(this,e)}return i(e,[{key:"init",value:function(e,n,t,i){if(arguments.length<2)throw new Error("init: invalid number of arguments");if(this.ctx=e,this.ASTy=!0,this.T=n,this.L={L:0,C:0,O:0},this.A={},this.C=[],this.P=null,"object"===(void 0===t?"undefined":r(t)))for(var o in t)t.hasOwnProperty(o)&&this.set(o,t[o]);return"object"===(void 0===i?"undefined":r(i))&&i instanceof Array&&this.add(i),this}},{key:"create",value:function(e,n,t){return this.ctx.create(e,n,t)}},{key:"type",value:function(e){if(0===arguments.length)return this.T;if(1===arguments.length)return this.T=e,this;throw new Error("type: invalid number of arguments")}},{key:"pos",value:function(e,n,t){if(0===arguments.length)return{line:this.L.L,column:this.L.C,offset:this.L.O};if(arguments.length<=3)return this.L.L=e||0,this.L.C=n||0,this.L.O=t||0,this;throw new Error("pos: invalid number of arguments")}},{key:"set",value:function(){for(var e=this,n=arguments.length,t=Array(n),i=0;i<n;i++)t[i]=arguments[i];if(1===t.length&&"object"===r(t[0]))Object.keys(t[0]).forEach(function(n){void 0!==t[0][n]?e.A[n]=t[0][n]:delete e.A[n]});else{if(2!==t.length)throw new Error("set: invalid number of arguments");void 0!==t[1]?this.A[t[0]]=t[1]:delete this.A[t[0]]}return this}},{key:"unset",value:function(){for(var e=this,n=arguments.length,t=Array(n),i=0;i<n;i++)t[i]=arguments[i];if(1===t.length&&"object"===r(t[0])&&t[0]instanceof Array)t[0].forEach(function(n){delete e.A[n]});else{if(1!==t.length)throw new Error("unset: invalid number of arguments");delete this.A[t[0]]}return this}},{key:"get",value:function(){for(var e=this,n=arguments.length,t=Array(n),i=0;i<n;i++)t[i]=arguments[i];if(1!==t.length)throw new Error("get: invalid number of arguments");if("object"===r(t[0])&&t[0]instanceof Array)return t[0].map(function(n){if("string"!=typeof n)throw new Error("get: invalid key argument");return e.A[n]});var o=t[0];if("string"!=typeof o)throw new Error("get: invalid key argument");return this.A[o]}},{key:"attrs",value:function(){return Object.keys(this.A)}},{key:"nth",value:function(){if(null===this.P)return 1;var e=this.P.C.indexOf(this);if(e<0)throw new Error("nth: internal error -- node not in childs of its parent");return e}},{key:"ins",value:function(e){for(var n=this,t=arguments.length,i=Array(t>1?t-1:0),o=1;o<t;o++)i[o-1]=arguments[o];if(0===i.length)throw new Error("ins: invalid number of arguments");if(e<0&&(e=this.C.length+1-e),!(e>=0&&e<=this.C.length))throw new Error("ins: invalid position");var u=function(t){if(!n.ctx.isA(t))throw new Error("ins: invalid AST node argument");n.C.splice(e++,0,t),t.P=n};return i.forEach(function(e){"object"===(void 0===e?"undefined":r(e))&&e instanceof Array?e.forEach(function(e){u(e)}):null!==e&&u(e)}),this}},{key:"add",value:function(){for(var e=this,n=arguments.length,t=Array(n),i=0;i<n;i++)t[i]=arguments[i];if(0===t.length)throw new Error("add: invalid number of arguments");var o=function(n){if(!e.ctx.isA(n))throw new Error("add: invalid AST node argument");e.C.push(n),n.P=e};return t.forEach(function(e){"object"===(void 0===e?"undefined":r(e))&&e instanceof Array?e.forEach(function(e){o(e)}):null!==e&&o(e)}),this}},{key:"del",value:function(){for(var e=this,n=arguments.length,t=Array(n),r=0;r<n;r++)t[r]=arguments[r];if(0===t.length)throw new Error("del: invalid number of arguments");return t.forEach(function(n){if(!e.ctx.isA(n))throw new Error("del: invalid AST node argument");for(var t=!1,r=0;r<e.C.length;r++)if(e.C[r]===n){e.C.splice(r,1),n.P=null,t=!0;break}if(!t)throw new Error("del: AST node not found in childs")}),this}},{key:"childs",value:function(){if(arguments.length>2)throw new Error("childs: invalid number of arguments");if(2===arguments.length&&"number"==typeof(arguments.length<=0?void 0:arguments[0])&&"number"==typeof(arguments.length<=1?void 0:arguments[1]))return this.C.slice(arguments.length<=0?void 0:arguments[0],arguments.length<=1?void 0:arguments[1]);if(1===arguments.length&&"number"==typeof(arguments.length<=0?void 0:arguments[0]))return this.C.slice(arguments.length<=0?void 0:arguments[0]);if(0===arguments.length)return this.C;throw new Error("childs: invalid type of arguments")}},{key:"child",value:function(e){if("number"!=typeof e)throw new Error("child: invalid argument");return e<this.C.length?this.C[e]:null}},{key:"parent",value:function(){return this.P}},{key:"serialize",value:function(){return this.ctx.__serialize(this)}}]),e}();t.default=o},{}],2:[function(e,n,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},i=function(){function e(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(n,t,r){return t&&e(n.prototype,t),r&&e(n,r),n}}();var o={unicode:String.fromCharCode(9500),ascii:"+"},u={unicode:String.fromCharCode(9492),ascii:"+"},a={unicode:String.fromCharCode(9474),ascii:"|"},f={unicode:String.fromCharCode(9472),ascii:"-"},l=function(){function e(){!function(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}(this,e)}return i(e,[{key:"dump",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1/0,n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:function(e,n){return n},t=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],i="",l=this;return this.walk(function(c,s){if(!(s>e)){if(s>0){var h=function(e){var n=0,t=0;return null!==e.P&&(n=e.P.C.indexOf(e),t=e.P.C.length-1),{nth:n,max:t}},d=h(c),y=d.nth,v=d.max,p=" ";p=t?""+f.unicode+f.unicode+p:""+f.ascii+f.ascii+p,p=y<v?""+(t?o.unicode:o.ascii)+p:""+(t?u.unicode:u.ascii)+p;for(var b=c.P;null!==b&&b!==l;b=b.P)if(null!==b.P){var g=h(b);p=g.nth<g.max?(t?a.unicode:a.ascii)+"   "+p:"    "+p}i+=n("tree",p)}i+=n("type",c.T)+" ";var m=Object.keys(c.A);if(m.length>0){i+=n("parenthesis","(");var w=!0;m.forEach(function(e){w?w=!1:i+=n("comma",",")+" ",i+=n("key",e)+n("colon",":")+" ";var t=c.A[e];switch(void 0===t?"undefined":r(t)){case"boolean":case"number":i+=n("value",t.toString());break;case"string":var o=function(e){return e.charCodeAt(0).toString(16).toUpperCase()};i+=n("value",'"'+t.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+o(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+o(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+o(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+o(e)})+'"');break;case"object":t instanceof RegExp?i+=n("value","/"+t.source+"/"):i+=n("value",JSON.stringify(t));break;default:i+=n("value",JSON.stringify(t))}}),i+=n("parenthesis",")")+" "}i+=n("position",n("bracket","[")+n("line",c.L.L)+n("slash",",")+n("column",c.L.C)+n("bracket","]")),i+="\n"}},"downward"),i}}]),e}();t.default=l},{}],3:[function(e,n,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(n,t,r){return t&&e(n.prototype,t),r&&e(n,r),n}}();var i=function(){function e(){!function(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}(this,e)}return r(e,[{key:"merge",value:function(e){var n=this,t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};if(null===e)return this;if(!this.ctx.isA(e))throw new Error("merge: invalid AST node argument");if(t){var i=e.pos();this.pos(i.line,i.column,i.offset)}e.attrs().forEach(function(t){var i=void 0!==r[t]?r[t]:t;null!==i&&n.set(i,e.get(t))}),e.childs().forEach(function(t){e.del(t),n.add(t)});var o=e.parent();return null!==o&&o.del(e),this}}]),e}();t.default=i},{}],4:[function(e,n,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},i=function(){function e(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(n,t,r){return t&&e(n.prototype,t),r&&e(n,r),n}}();var o=function(){function e(){!function(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}(this,e)}return i(e,null,[{key:"serialize",value:function(e,n){if(!e.isA(n))throw new Error("serialize: not an ASTy node");return JSON.stringify({ASTy:function e(n){var t={T:n.T,L:{L:n.L.L,C:n.L.C,O:n.L.O}},i=Object.keys(n.A);return i.length>0&&(t.A={},i.forEach(function(e){var i=n.A[e];switch(void 0===i?"undefined":r(i)){case"boolean":case"number":case"string":t.A[e]=i;break;default:t.A[e]=JSON.parse(JSON.stringify(i))}})),n.C.length>0&&(t.C=n.C.map(function(n){return e(n)})),t}(n)})}},{key:"unserialize",value:function(e,n){var t=JSON.parse(n);if("object"!==(void 0===t?"undefined":r(t))||"object"!==r(t.ASTy))throw new Error("unserialize: not an ASTy JSON export");return function n(t){var i=e.create(t.T);return i.pos(t.L.L,t.L.C,t.L.O),"object"===r(t.A)&&Object.keys(t.A).forEach(function(e){var n=t.A[e];switch(void 0===n?"undefined":r(n)){case"boolean":case"number":case"string":i.set(e,n);break;default:i.set(e,JSON.parse(JSON.stringify(n)))}}),"object"===r(t.C)&&t.C instanceof Array&&i.add(t.C.map(function(e){return n(e)})),i}(t.ASTy)}}]),e}();t.default=o},{}],5:[function(e,n,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.default={major:1,minor:7,micro:14,date:20180623}},{}],6:[function(e,n,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(n,t,r){return t&&e(n.prototype,t),r&&e(n,r),n}}();var i=function(){function e(){!function(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}(this,e)}return r(e,[{key:"walk",value:function(e){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"downward";return function t(r,i,o){"downward"!==n&&"both"!==n||e(r,i,o,"downward"),r.C.forEach(function(e){t(e,i+1,r)}),"upward"!==n&&"both"!==n||e(r,i,o,"upward")}(this,0,null),this}}]),e}();t.default=i},{}],7:[function(e,n,t){"use strict";var r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},i=function(){function e(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(n,t,r){return t&&e(n.prototype,t),r&&e(n,r),n}}(),o=s(e("./asty-base.js")),u=s(e("./asty-merge.js")),a=s(e("./asty-walk.js")),f=s(e("./asty-dump.js")),l=s(e("./asty-serialize.js")),c=s(e("./asty-version.js"));function s(e){return e&&e.__esModule?e:{default:e}}var h=function(){function e(){var n=this;return function(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}(this,e),this.ASTYNode=function(){},[[o.default,"init","create","type","pos","set","unset","get","attrs","nth","ins","add","del","childs","child","parent","serialize"],[u.default,"merge"],[a.default,"walk"],[f.default,"dump"]].forEach(function(e){var t=e[0].prototype;e.slice(1).forEach(function(e){n.ASTYNode.prototype[e]=t[e]})}),this}return i(e,[{key:"version",value:function(){return c.default}},{key:"extend",value:function(e){for(var n in e)e.hasOwnProperty(n)&&(this.ASTYNode.prototype[n]=e[n]);return this}},{key:"create",value:function(e,n,t){return(new this.ASTYNode).init(this,e,n,t)}},{key:"isA",value:function(e){return"object"===(void 0===e?"undefined":r(e))&&e instanceof this.ASTYNode&&"boolean"==typeof e.ASTy&&!0===e.ASTy}},{key:"__serialize",value:function(n){return e.serialize(n)}}],[{key:"serialize",value:function(e){return l.default.serialize(e.ctx,e)}},{key:"unserialize",value:function(e){return l.default.unserialize(new this,e)}}]),e}();n.exports=h},{"./asty-base.js":1,"./asty-dump.js":2,"./asty-merge.js":3,"./asty-serialize.js":4,"./asty-version.js":5,"./asty-walk.js":6}]},{},[1,2,3,4,5,6,7])(7)});
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],2:[function(_dereq_,module,exports){
(function (global){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).CacheLRU=e()}}(function(){return function(){return function e(t,n,i){function r(u,s){if(!n[u]){if(!t[u]){var l="function"==typeof _dereq_&&_dereq_;if(!s&&l)return l(u,!0);if(o)return o(u,!0);var h=new Error("Cannot find module '"+u+"'");throw h.code="MODULE_NOT_FOUND",h}var a=n[u]={exports:{}};t[u][0].call(a.exports,function(e){return r(t[u][1][e]||e)},a,a.exports,e,t,n,i)}return n[u].exports}for(var o="function"==typeof _dereq_&&_dereq_,u=0;u<i.length;u++)r(i[u]);return r}}()({1:[function(e,t,n){"use strict";var i=function(){function e(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}return function(t,n,i){return n&&e(t.prototype,n),i&&e(t,i),t}}();var r=function(){function e(){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._index={},this._LRU={newer:null},this._MRU={older:null},this._LRU.newer=this._MRU,this._MRU.older=this._LRU,this._cur=0,this._max=1/0,this._dispose=function(){},this}return i(e,[{key:"limit",value:function(e){var t=this._max;return arguments.length>0&&(this._max=e,this._purge()),t}},{key:"dispose",value:function(e){return this._dispose=e,this}},{key:"length",value:function(){return this._cur}},{key:"keys",value:function(){return this.each(function(e,t){this.push(t)},[])}},{key:"values",value:function(){return this.each(function(e){this.push(e)},[])}},{key:"each",value:function(e,t){arguments<2&&(t=this);for(var n=0,i=this._MRU.older;i!==this._LRU;)e.call(t,i.val,i.key,n++),i=i.older;return t}},{key:"has",value:function(e){return void 0!==this._index[e]}},{key:"peek",value:function(e){var t=this._index[e];if(void 0!==t){if(!(t.expires<Date.now()))return t.val;this.del(t.key)}}},{key:"touch",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("touch: no such item");return this._promote(t),this}},{key:"get",value:function(e){var t=this._index[e];if(void 0!==t){if(!(t.expires<Date.now()))return this._promote(t),t.val;this.del(t.key)}}},{key:"set",value:function(e,t,n){arguments.length<3&&(n=1/0),n+=Date.now();var i=this._index[e];if(void 0===i)i={older:null,newer:null,key:e,val:t,expires:n},this._index[e]=i,this._attach(i),this._cur++,this._purge();else{var r=i.val;i.val=t,this._promote(i),this._dispose.call(void 0,i.key,r,"set")}return this}},{key:"del",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("del: no such item");return delete this._index[e],this._detach(t),this._cur--,this._dispose.call(void 0,e,t.val,"del"),this}},{key:"clear",value:function(){for(;this._cur>0;)this.del(this._LRU.newer.key);return this}},{key:"_purge",value:function(){for(;this._cur>this._max;)this.del(this._LRU.newer.key)}},{key:"_promote",value:function(e){this._detach(e),this._attach(e)}},{key:"_detach",value:function(e){e.older.newer=e.newer,e.newer.older=e.older,e.older=null,e.newer=null}},{key:"_attach",value:function(e){e.older=this._MRU.older,e.newer=this._MRU,e.newer.older=e,e.older.newer=e}}]),e}();t.exports=r},{}]},{},[1])(1)});
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],3:[function(_dereq_,module,exports){
(function (global){
!function(e,n,r){"object"==typeof module&&"object"==typeof module.exports?module.exports=r():"function"==typeof define&&void 0!==define.amd?define("PEGUtil",function(){return r()}):e.PEGUtil=r()}("undefined"!=typeof global?global:"undefined"!=typeof window?window:this,0,function(){var e={makeAST:function(e,n){return function(){return n.util.__makeAST.call(null,e().start.line,e().start.column,e().start.offset,arguments)}},makeUnroll:function(e,n){return function(r,t,o){if("object"!=typeof t||!(t instanceof Array))throw new n.util.__SyntaxError("unroll: invalid list argument for unrolling",typeof t,"Array",e());if(void 0!==o){"number"==typeof o&&(o=[o]);var l=[];null!==r&&l.push(r);for(var a=0;a<t.length;a++)for(var i=0;i<o.length;i++)l.push(t[a][o[i]]);return l}return null!==r&&t.unshift(r),t}}},n=function(e,n){var r=e.length,t=n-20;t<0&&(t=0);var o=n+20;o>r&&(o=r);var l=function(e){return e.charCodeAt(0).toString(16).toUpperCase()},a=function(e,n,r){return e.substr(n,r).replace(/\\/g,"\\\\").replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+l(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+l(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+l(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+l(e)})};return{prolog:a(e,t,n-t),token:a(e,n,1),epilog:a(e,n+1,o-(n+1))}};return e.parse=function(r,t,o){if("object"!=typeof r)throw new Error("invalid parser object (not an object)");if("function"!=typeof r.parse)throw new Error('invalid parser object (no "parse" function)');if("string"!=typeof t)throw new Error("invalid input text (not a string)");if(void 0!==o&&"object"!=typeof o)throw new Error("invalid options (not an object)");void 0===o&&(o={});var l={ast:null,error:null};try{var a;a="function"==typeof o.makeAST?o.makeAST:function(e,n){return{line:e().start.line,column:e().start.column,offset:e().start.offset,args:n}},o.util={makeUnroll:e.makeUnroll,makeAST:e.makeAST,__makeAST:a,__SyntaxError:r.SyntaxError},l.ast=r.parse(t,o),l.error=null}catch(e){if(l.ast=null,e instanceof r.SyntaxError){var i=function(e,n){return void 0!==e?e:n};l.error={line:i(e.location.start.line,0),column:i(e.location.start.column,0),message:e.message,found:i(e.found,""),expected:i(e.expected,""),location:n(t,i(e.location.start.offset,0))}}else l.error={line:0,column:0,message:e.message,found:"",expected:"",location:n("",0)}}return l},e.errorMessage=function(e,n){for(var r=e.location,t="line "+e.line+" (column "+e.column+"): ",o="",l=0;l<t.length+r.prolog.length;l++)o+="-";return t+r.prolog+r.token+r.epilog+"\n"+o+"^\n"+e.message+(n?"":"\n")},e});
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],4:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_createClass=function(){function e(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}return function(t,n,o){return n&&e(t.prototype,n),o&&e(t,o),t}}();function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var ASTQAdapterASTY=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===(void 0===e?"undefined":_typeof(e))&&null!==e&&"boolean"==typeof e.ASTy}},{key:"getParentNode",value:function(e){return e.parent()}},{key:"getChildNodes",value:function(e){return e.childs()}},{key:"getNodeType",value:function(e){return e.type()}},{key:"getNodeAttrNames",value:function(e){return e.attrs()}},{key:"getNodeAttrValue",value:function(e,t){return e.get(t)}}]),e}();exports.default=ASTQAdapterASTY;
},{}],5:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_createClass=function(){function e(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}return function(t,n,o){return n&&e(t.prototype,n),o&&e(t,o),t}}();function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var ASTQAdapterGraphQL=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===(void 0===e?"undefined":_typeof(e))&&null!==e&&"string"==typeof e.kind&&""!==e.kind}},{key:"getParentNode",value:function(e,t){throw new Error("GraphQL AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var n=this,o=[],r=function(e,t){e.hasOwnProperty(t)&&n.taste(e[t])?o.push(e[t]):e.hasOwnProperty(t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){n.taste(e)&&o.push(e)})};if("*"===t)for(var a in e)r(e,a);else{if(void 0===e[t])throw new Error('no such axis named "'+t+'" for walking to child nodes');r(e,t)}return o}},{key:"getNodeType",value:function(e){return e.kind}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var n in e)e.hasOwnProperty(n)&&"object"!==_typeof(e[n])&&"kind"!==n&&"loc"!==n&&t.push(n);return t}},{key:"getNodeAttrValue",value:function(e,t){return e.hasOwnProperty(t)&&"object"!==_typeof(e[t])&&"kind"!==t&&"loc"!==t?e[t]:void 0}}]),e}();exports.default=ASTQAdapterGraphQL;
},{}],6:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_createClass=function(){function e(e,t){for(var o=0;o<t.length;o++){var r=t[o];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,o,r){return o&&e(t.prototype,o),r&&e(t,r),t}}();function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var ASTQAdapterMozAST=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===(void 0===e?"undefined":_typeof(e))&&null!==e&&"string"==typeof e.type&&""!==e.type}},{key:"getParentNode",value:function(e,t){if("*"!==t&&"parent"!==t)throw new Error('no such axis named "'+t+'" for walking to parent nodes');if(void 0!==e.parent)return e.parent;throw new Error("Your Mozilla SpiderMonkey AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var o=this,r=[],n=function(e,t){e.hasOwnProperty(t)&&o.taste(e[t])?r.push(e[t]):e.hasOwnProperty(t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){o.taste(e)&&r.push(e)})};if("*"===t)for(var a in e)n(e,a);else{if(void 0===e[t])throw new Error('no such axis named "'+t+'" for walking to child nodes');n(e,t)}return r}},{key:"getNodeType",value:function(e){return e.type}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var o in e)e.hasOwnProperty(o)&&"object"!==_typeof(e[o])&&"type"!==o&&"loc"!==o&&t.push(o);return t}},{key:"getNodeAttrValue",value:function(e,t){return e.hasOwnProperty(t)&&"object"!==_typeof(e[t])&&"type"!==t&&"loc"!==t?e[t]:void 0}}]),e}();exports.default=ASTQAdapterMozAST;
},{}],7:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_createClass=function(){function e(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}return function(t,n,o){return n&&e(t.prototype,n),o&&e(t,o),t}}();function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var ASTQAdapterParse5=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===(void 0===e?"undefined":_typeof(e))&&null!==e&&!("object"===("undefined"==typeof Node?"undefined":_typeof(Node))&&e instanceof Node)&&"string"==typeof e.nodeName&&""!==e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&e.childNodes instanceof Array?e.childNodes:[]}},{key:"getNodeType",value:function(e){return e.nodeName}},{key:"getNodeAttrNames",value:function(e){var t=["value"];return"object"===_typeof(e.attrs)&&e.attrs instanceof Array&&(t=t.concat(e.attrs.map(function(e){return e.name}))),t}},{key:"getNodeAttrValue",value:function(e,t){var n=void 0;if("value"===t)n=e.value;else if("object"===_typeof(e.attrs)&&e.attrs instanceof Array){var o=e.attrs.filter(function(e){return e.name===t}).map(function(e){return e.value});1===o.length&&(n=o[0])}return n}}]),e}();exports.default=ASTQAdapterParse5;
},{}],8:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_createClass=function(){function e(e,t){for(var o=0;o<t.length;o++){var n=t[o];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,o,n){return o&&e(t.prototype,o),n&&e(t,n),t}}();function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var ASTQAdapterXMLDOM=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===("undefined"==typeof Node?"undefined":_typeof(Node))&&null!==e&&e instanceof Node&&"object"===(void 0===e?"undefined":_typeof(e))&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&null!==e.childNodes&&e.hasChildNodes()?Array.prototype.slice.call(e.childNodes,0):[]}},{key:"getNodeType",value:function(e){return"string"==typeof e.nodeName?e.nodeName:"unknown"}},{key:"getNodeAttrNames",value:function(e){return"object"===_typeof(e.attributes)&&null!==e.attributes&&e.hasAttributes()?Array.prototype.slice.call(e.attributes,0).map(function(e){return e.nodeName}):[]}},{key:"getNodeAttrValue",value:function(e,t){return"object"===_typeof(e.attributes)&&null!==e.attributes&&e.hasAttributes()?e.getAttribute(t):void 0}}]),e}();exports.default=ASTQAdapterXMLDOM;
},{}],9:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var a=0;a<t.length;a++){var r=t[a];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,a,r){return a&&e(t.prototype,a),r&&e(t,r),t}}();function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var ASTQAdapter=function(){function e(){return _classCallCheck(this,e),this._adapters=[],this}return _createClass(e,[{key:"register",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this._adapters.unshift({adapter:e,force:t}),this}},{key:"unregister",value:function(e){if(void 0===e)this._adapters=[];else{for(var t=[],a=0;a<this._adapters.length;a++)this._adapters[a].adapter!==e&&t.push(this._adapters[a]);this._adapters=t}return this}},{key:"select",value:function(e){for(var t=0;t<this._adapters.length;t++)if(this._adapters[t].force||this._adapters[t].adapter.taste(e))return this._adapters[t].adapter}}]),e}();exports.default=ASTQAdapter;
},{}],10:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},_pos=function(t,n){var e=t.getParentNode(n,"*");if(null===e)return 1;for(var r=t.getChildNodes(e,"*"),o=0;o<r.length;o++)if(r[o]===n)return o+1;throw new Error("cannot find myself")},parents=function(t,n){for(var e=[];null!==(n=t.getParentNode(n,"*"));)e.push(n);return e},stdfuncs={type:function(t,n){return t.getNodeType(n)},attrs:function(t,n,e){return void 0===e&&(e=" "),e+t.getNodeAttrNames(n).join(e)+e},depth:function(t,n){for(var e=1,r=n;null!==(r=t.getParentNode(r,"*"));)e++;return e},pos:function(t,n){return _pos(t,n)},nth:function(t,n,e){e=parseInt(e,10);var r=t.getParentNode(n,"*");if(null!==r){var o=t.getChildNodes(r,"*");e<0&&(e=o.length-(e+1));for(var u=0;u<o.length;u++)if(o[u]===n)return u+1===e;return!1}return 1===e},first:function(t,n){return stdfuncs.nth(t,n,1)},last:function(t,n){return stdfuncs.nth(t,n,-1)},count:function(t,n,e){return"object"===(void 0===e?"undefined":_typeof(e))&&e instanceof Array?e.length:"object"===(void 0===e?"undefined":_typeof(e))?Object.keys(e).length:"string"==typeof e?e.length:String(e).length},below:function(t,n,e){if(!t.taste(e))throw new Error('invalid argument to function "below" (node expected)');for(var r=n;null!==(r=t.getParentNode(r,"*"));)if(r===e)return!0;return!1},follows:function(t,n,e){if(!t.taste(e))throw new Error('invalid argument to function "follows" (node expected)');if(n===e)return!1;var r=[n].concat(parents(t,n)).reverse(),o=[e].concat(parents(t,e)).reverse(),u=Math.min(r.length,o.length),i=void 0;for(i=0;i<u&&r[i]===o[i];i++);if(0===i)throw new Error("internal error: root nodes have to be same same");return i===u?o.length<r.length:_pos(t,r[i])>_pos(t,o[i])},in:function(t,n,e){if(!("object"===(void 0===e?"undefined":_typeof(e))&&e instanceof Array))throw new Error('invalid argument to function "in" (array expected)');for(var r=0;r<e.length;r++)if(e[r]===n)return!0;return!1},substr:function(t,n,e,r,o){return String(e).substr(r,o)},index:function(t,n,e,r,o){return String(e).indexOf(r,o)},trim:function(t,n,e){return String(e).trim()},lc:function(t,n,e){return String(e).toLowerCase()},uc:function(t,n,e){return String(e).toUpperCase()}};exports.default=stdfuncs;
},{}],11:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(n,t,r){return t&&e(n.prototype,t),r&&e(n,r),n}}();function _classCallCheck(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}var ASTQFuncs=function(){function e(){return _classCallCheck(this,e),this._funcs={},this}return _createClass(e,[{key:"register",value:function(e,n){this._funcs[e]=n}},{key:"run",value:function(e,n){var t=this._funcs[e];if("function"!=typeof t)throw new Error('invalid function "'+e+'"');return t.apply(null,n)}}]),e}();exports.default=ASTQFuncs;
},{}],12:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}return function(t,r,a){return r&&e(t.prototype,r),a&&e(t,a),t}}(),_astqUtil=_dereq_("./astq-util.js"),_astqUtil2=_interopRequireDefault(_astqUtil),_astqQueryTrace=_dereq_("./astq-query-trace.js"),_astqQueryTrace2=_interopRequireDefault(_astqQueryTrace);function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var ASTQQueryExec=function(e){function t(e,r,a,i){_classCallCheck(this,t);var n=_possibleConstructorReturn(this,(t.__proto__||Object.getPrototypeOf(t)).call(this));return n.adapter=e,n.params=r,n.funcs=a,n.trace=i,n}return _inherits(t,_astqQueryTrace2.default),_createClass(t,[{key:"execQuery",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[];return e.childs().forEach(function(e){a=a.concat(r.execPath(e,t))}),this.traceEnd(e,t,a),a}},{key:"execPath",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[t],i=[],n=!1;return e.childs().forEach(function(e){var t=[];a.forEach(function(a){t=t.concat(r.execStep(e,a))}),a=t,e.get("isResult")&&(n=!0,i=i.concat(a))}),this.traceEnd(e,t,a),n?i:a}},{key:"execStep",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.childs(),i=null,n=null,c=null,s=0;if(s<a.length&&"Axis"===a[s].type()&&(i=a[s++]),s<a.length&&"Match"===a[s].type()&&(n=a[s++]),s<a.length&&"Filter"===a[s].type()&&(c=a[s++]),null===n)throw new Error("no matching part in query step");var l=[],u=n.get("id"),o=function(e){var t=r.adapter.getNodeType(e);if("*"===u||u===t){var a=!0;null!==c&&(r.execFilter(c,e)||(a=!1)),a&&l.push(e)}};if(null!==i){var h=i.get("op"),d=i.get("type");if("/"===h)this.adapter.getChildNodes(t,d).forEach(function(e){return o(e)});else if("//"===h){this.adapter.getChildNodes(t,d).forEach(function(e){return function e(t){o(t),r.adapter.getChildNodes(t,d).forEach(function(t){return e(t)})}(e)})}else if("./"===h)o(t),this.adapter.getChildNodes(t,d).forEach(function(e){return o(e)});else if(".//"===h){o(t);this.adapter.getChildNodes(t,d).forEach(function(e){return function e(t){o(t),r.adapter.getChildNodes(t,d).forEach(function(t){return e(t)})}(e)})}else if("-/"===h){var f=this.adapter.getParentNode(t,"*");if(null!==f){for(var p=this.adapter.getChildNodes(f,d),x=null,g=0;g<p.length&&p[g]!==t;g++)x=p[g];null!==x&&o(x)}}else if("-//"===h){var E=this.adapter.getParentNode(t,"*");if(null!==E){for(var v=this.adapter.getChildNodes(E,d),b=0;b<v.length&&v[b]!==t;b++);for(b--;b>=0;b--)o(v[b])}}else if("+/"===h){var y=this.adapter.getParentNode(t,"*");if(null!==y){var _=this.adapter.getChildNodes(y,d),q=void 0;for(q=0;q<_.length&&_[q]!==t;q++);q<_.length&&o(_[++q])}}else if("+//"===h){var k=this.adapter.getParentNode(t,"*");if(null!==k){var m=this.adapter.getChildNodes(k,d),U=void 0;for(U=0;U<m.length&&m[U]!==t;U++);if(U<m.length)for(U++;U<m.length;U++)o(m[U])}}else if("~/"===h){var C=this.adapter.getParentNode(t,"*");if(null!==C){var N=this.adapter.getChildNodes(C,d),B=void 0;for(B=0;B<N.length&&N[B]!==t;B++);B>0&&o(N[B-1]),B<N.length-1&&o(N[B+1])}}else if("~//"===h){var P=this.adapter.getParentNode(t,"*");if(null!==P)for(var w=this.adapter.getChildNodes(P,d),L=0;L<w.length;L++)w[L]!==t&&o(w[L])}else if("../"===h){var R=this.adapter.getParentNode(t,d);null!==R&&o(R)}else if("..//"===h)for(var T=t;;){var A=this.adapter.getParentNode(T,d);if(null===A)break;o(A),T=A}else if("<//"===h){for(var j={sentinel:t,take:!0};;){var O=this.adapter.getParentNode(t,"*");if(null===O)break;t=O}t!==j.sentinel&&(o(t),this.adapter.getChildNodes(t,d).forEach(function(e){return function e(t){t===j.sentinel&&(j.take=!1),j.take&&o(t),j.take&&r.adapter.getChildNodes(t,d).forEach(function(t){return e(t)})}(e)})),l=l.reverse()}else if(">//"===h){for(var Q={sentinel:t,take:!1};;){var S=this.adapter.getParentNode(t,"*");if(null===S)break;t=S}this.adapter.getChildNodes(t,d).forEach(function(e){return function e(t){Q.take&&o(t),t===Q.sentinel&&(Q.take=!0),r.adapter.getChildNodes(t,d).forEach(function(t){return e(t)})}(e)})}}else o(t);return this.traceEnd(e,t,l),l}},{key:"execFilter",value:function(e,t){this.traceBegin(e,t);var r=e.childs()[0],a=this.execExpr(r,t);return a=_astqUtil2.default.truthy(a),this.traceEnd(e,t,a),a}},{key:"execExpr",value:function(e,t){switch(e.type()){case"ConditionalBinary":return this.execExprConditionalBinary(e,t);case"ConditionalTernary":return this.execExprConditionalTernary(e,t);case"Logical":return this.execExprLogical(e,t);case"Bitwise":return this.execExprBitwise(e,t);case"Relational":return this.execExprRelational(e,t);case"Arithmetical":return this.execExprArithmetical(e,t);case"Unary":return this.execExprUnary(e,t);case"FuncCall":return this.execExprFuncCall(e,t);case"Attribute":return this.execExprAttribute(e,t);case"Param":return this.execExprParam(e,t);case"LiteralString":return this.execExprLiteralString(e,t);case"LiteralRegExp":return this.execExprLiteralRegExp(e,t);case"LiteralNumber":return this.execExprLiteralNumber(e,t);case"LiteralValue":return this.execExprLiteralValue(e,t);case"Path":return this.execExprPath(e,t)}}},{key:"execExprConditionalBinary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return _astqUtil2.default.truthy(r)||(r=this.execExpr(e.childs()[1],t)),this.traceEnd(e,t,r),r}},{key:"execExprConditionalTernary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return r=_astqUtil2.default.truthy(r)?this.execExpr(e.childs()[1],t):this.execExpr(e.childs()[2],t),this.traceEnd(e,t,r),r}},{key:"execExprLogical",value:function(e,t){this.traceBegin(e,t);var r=!1;switch(e.get("op")){case"&&":(r=_astqUtil2.default.truthy(this.execExpr(e.childs()[0],t)))&&(r=r&&_astqUtil2.default.truthy(this.execExpr(e.childs()[1],t)));break;case"||":(r=_astqUtil2.default.truthy(this.execExpr(e.childs()[0],t)))||(r=r||_astqUtil2.default.truthy(this.execExpr(e.childs()[1],t)))}return this.traceEnd(e,t,r),r}},{key:"execExprBitwise",value:function(e,t){this.traceBegin(e,t);var r=_astqUtil2.default.coerce(this.execExpr(e.childs()[0],t),"number"),a=_astqUtil2.default.coerce(this.execExpr(e.childs()[1],t),"number"),i=void 0;switch(e.get("op")){case"&":i=r&a;break;case"|":i=r|a;break;case"<<":i=r<<a;break;case">>":i=r>>a}return this.traceEnd(e,t,i),i}},{key:"execExprRelational",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t),a=this.execExpr(e.childs()[1],t),i=void 0;switch(e.get("op")){case"==":i=r===a;break;case"!=":i=r!==a;break;case"<=":i=_astqUtil2.default.coerce(r,"number")<=_astqUtil2.default.coerce(a,"number");break;case">=":i=_astqUtil2.default.coerce(r,"number")>=_astqUtil2.default.coerce(a,"number");break;case"<":i=_astqUtil2.default.coerce(r,"number")<_astqUtil2.default.coerce(a,"number");break;case">":i=_astqUtil2.default.coerce(r,"number")>_astqUtil2.default.coerce(a,"number");break;case"=~":i=null!==_astqUtil2.default.coerce(r,"string").match(_astqUtil2.default.coerce(a,"regexp"));break;case"!~":i=null===_astqUtil2.default.coerce(r,"string").match(_astqUtil2.default.coerce(a,"regexp"))}return this.traceEnd(e,t,i),i}},{key:"execExprArithmetical",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t),a=this.execExpr(e.childs()[1],t),i=void 0;switch(e.get("op")){case"+":i="string"==typeof r?r+_astqUtil2.default.coerce(a,"string"):_astqUtil2.default.coerce(r,"number")+_astqUtil2.default.coerce(a,"number");break;case"-":i=_astqUtil2.default.coerce(r,"number")+_astqUtil2.default.coerce(a,"number");break;case"*":i=_astqUtil2.default.coerce(r,"number")*_astqUtil2.default.coerce(a,"number");break;case"/":i=_astqUtil2.default.coerce(r,"number")/_astqUtil2.default.coerce(a,"number");break;case"%":i=_astqUtil2.default.coerce(r,"number")%_astqUtil2.default.coerce(a,"number");break;case"**":i=Math.pow(_astqUtil2.default.coerce(r,"number"),_astqUtil2.default.coerce(a,"number"))}return this.traceEnd(e,t,i),i}},{key:"execExprUnary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t),a=void 0;switch(e.get("op")){case"!":a=!_astqUtil2.default.coerce(r,"boolean");break;case"~":a=~_astqUtil2.default.coerce(r,"number")}return this.traceEnd(e,t,a),a}},{key:"execExprFuncCall",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.get("id"),i=[this.adapter,t];e.childs().forEach(function(e){i.push(r.execExpr(e,t))});var n=this.funcs.run(a,i);return this.traceEnd(e,t,n),n}},{key:"execExprAttribute",value:function(e,t){this.traceBegin(e,t);var r=e.get("id"),a=this.adapter.getNodeAttrValue(t,r);return this.traceEnd(e,t,a),a}},{key:"execExprParam",value:function(e,t){this.traceBegin(e,t);var r=e.get("id");if(void 0===this.params[r])throw new Error('invalid parameter "'+r+'"');var a=this.params[r];return this.traceEnd(e,t,a),a}},{key:"execExprLiteralString",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralRegExp",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralNumber",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralValue",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprPath",value:function(e,t){this.traceBegin(e,t);var r=this.execPath(e,t);return this.traceEnd(e,t,r),r}}]),t}();exports.default=ASTQQueryExec;
},{"./astq-query-trace.js":13,"./astq-util.js":15}],13:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}return function(t,r,a){return r&&e(t.prototype,r),a&&e(t,a),t}}(),_astqUtil=_dereq_("./astq-util.js"),_astqUtil2=_interopRequireDefault(_astqUtil);function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var ASTQQueryTrace=function(){function e(){_classCallCheck(this,e)}return _createClass(e,[{key:"prefixOf",value:function(e,t){for(var r=0,a=e;null!==(a=a.parent());)r++;var n=_astqUtil2.default.pad("",4*r);for(r=0,a=t;null!==(a=this.adapter.getParentNode(a,"*"));)r++;return{prefix1:n,prefix2:_astqUtil2.default.pad("",4*r)}}},{key:"traceBegin",value:function(e,t){if(this.trace){var r=this.prefixOf(e,t),a=r.prefix1,n=r.prefix2;console.log("ASTQ: execute: | "+_astqUtil2.default.pad(a+e.type()+" (",-60)+" | "+n+this.adapter.getNodeType(t))}}},{key:"traceEnd",value:function(e,t,r){var a=this;if(this.trace){var n=this.prefixOf(e,t),o=n.prefix1,i=n.prefix2,f=void 0;void 0===r?f="undefined":"object"===(void 0===r?"undefined":_typeof(r))&&r instanceof Array?(f="[",r.forEach(function(e){f+="node("+a.adapter.getNodeType(e)+"),"}),f=f.replace(/,$/,"")+"]"):f=(void 0===r?"undefined":_typeof(r))+"("+r+")",f.length>60&&(f=f.substr(0,60)+"..."),console.log("ASTQ: execute: | "+_astqUtil2.default.pad(o+"): "+f,-60)+" | "+i+this.adapter.getNodeType(t))}}}]),e}();exports.default=ASTQQueryTrace;
},{"./astq-util.js":15}],14:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function t(t,r){for(var e=0;e<r.length;e++){var n=r[e];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(r,e,n){return e&&t(r.prototype,e),n&&t(r,n),r}}(),_asty=_dereq_("asty"),_asty2=_interopRequireDefault(_asty),_pegjsUtil=_dereq_("pegjs-util"),_pegjsUtil2=_interopRequireDefault(_pegjsUtil),_astqQueryExec=_dereq_("./astq-query-exec.js"),_astqQueryExec2=_interopRequireDefault(_astqQueryExec);function _interopRequireDefault(t){return t&&t.__esModule?t:{default:t}}function _classCallCheck(t,r){if(!(t instanceof r))throw new TypeError("Cannot call a class as a function")}var ASTQQueryParse=function(){function t(r,e,n,u){this.message=r,this.expected=e,this.found=n,this.location=u,this.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(this,t)}return function(t,r){function e(){this.constructor=t}e.prototype=r.prototype,t.prototype=new e}(t,Error),t.buildMessage=function(t,r){var e={literal:function(t){return'"'+u(t.text)+'"'},class:function(t){var r,e="";for(r=0;r<t.parts.length;r++)e+=t.parts[r]instanceof Array?s(t.parts[r][0])+"-"+s(t.parts[r][1]):s(t.parts[r]);return"["+(t.inverted?"^":"")+e+"]"},any:function(t){return"any character"},end:function(t){return"end of input"},other:function(t){return t.description}};function n(t){return t.charCodeAt(0).toString(16).toUpperCase()}function u(t){return t.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(t){return"\\x0"+n(t)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(t){return"\\x"+n(t)})}function s(t){return t.replace(/\\/g,"\\\\").replace(/\]/g,"\\]").replace(/\^/g,"\\^").replace(/-/g,"\\-").replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(t){return"\\x0"+n(t)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(t){return"\\x"+n(t)})}return"Expected "+function(t){var r,n,u,s=new Array(t.length);for(r=0;r<t.length;r++)s[r]=(u=t[r],e[u.type](u));if(s.sort(),s.length>0){for(r=1,n=1;r<s.length;r++)s[r-1]!==s[r]&&(s[n]=s[r],n++);s.length=n}switch(s.length){case 1:return s[0];case 2:return s[0]+" or "+s[1];default:return s.slice(0,-1).join(", ")+", or "+s[s.length-1]}}(t)+" but "+function(t){return t?'"'+u(t)+'"':"end of input"}(r)+" found."},{SyntaxError:t,parse:function(r,e){e=void 0!==e?e:{};var n,u={},s={query:Dn},a=Dn,o=function(t){return t},c=",",i=jn(",",!1),l=function(t,r){return pu("Query").add(du(t,r,3))},f=function(t,r){return pu("Path").add(du(t,r,1))},h="!",A=jn("!",!1),d=function(t,r,e,n){return pu("Step").add(t,r,n).set(null!==e?{isResult:!0}:{})},p=Mn("axis"),x="//",b=jn("//",!1),g="/",v=jn("/",!1),P="-//",C=jn("-//",!1),y="-/",m=jn("-/",!1),_="+//",q=jn("+//",!1),Q="+/",S=jn("+/",!1),w="~//",E=jn("~//",!1),R="~/",T=jn("~/",!1),F="..//",L=jn("..//",!1),k="../",j=jn("../",!1),N=".//",M=jn(".//",!1),U="./",I=jn("./",!1),V="<//",z=jn("<//",!1),D=">//",Z=jn(">//",!1),O=function(t,r){return pu("Axis").set({op:t,type:null!==r?r:"*"})},B=":",$=jn(":",!1),G=function(t){return t.get("id")},H=function(t){return t.get("value")},J=function(t){return pu("Match").merge(t)},K=function(t){return pu("Match").set({id:t.get("value")})},W="*",X=jn("*",!1),Y=function(){return pu("Match").set({id:"*"})},tt="[",rt=jn("[",!1),et="]",nt=jn("]",!1),ut=function(t){return pu("Filter").add(t)},st="?:",at=jn("?:",!1),ot=function(t,r){return pu("ConditionalBinary").add(t,r)},ct="?",it=jn("?",!1),lt=function(t,r,e){return pu("ConditionalTernary").add(t,r,e)},ft="||",ht=jn("||",!1),At=function(t,r,e){return pu("Logical").set({op:r}).add(t,e)},dt="&&",pt=jn("&&",!1),xt="|",bt=jn("|",!1),gt=function(t,r,e){return pu("Bitwise").set({op:r}).add(t,e)},vt="^",Pt=jn("^",!1),Ct="&",yt=jn("&",!1),mt="==",_t=jn("==",!1),qt="!=",Qt=jn("!=",!1),St="<=",wt=jn("<=",!1),Et=">=",Rt=jn(">=",!1),Tt="<",Ft=jn("<",!1),Lt=">",kt=jn(">",!1),jt="=~",Nt=jn("=~",!1),Mt="!~",Ut=jn("!~",!1),It=function(t,r,e){return pu("Relational").set({op:r}).add(t,e)},Vt="<<",zt=jn("<<",!1),Dt=">>",Zt=jn(">>",!1),Ot="+",Bt=jn("+",!1),$t="-",Gt=jn("-",!1),Ht=function(t,r,e){return pu("Arithmetical").set({op:r}).add(t,e)},Jt="**",Kt=jn("**",!1),Wt="%",Xt=jn("%",!1),Yt="~",tr=jn("~",!1),rr=function(t,r){return pu("Unary").set({op:t}).add(r)},er="(",nr=jn("(",!1),ur=")",sr=jn(")",!1),ar=function(t,r){return pu("FuncCall").merge(t).add(r)},or=function(t,r){return du(t,r,3)},cr=Mn("node attribute"),ir="@",lr=jn("@",!1),fr=function(t){return pu("Attribute").merge(t)},hr=function(t){return pu("Attribute").set({id:t.get("value")})},Ar=Mn("query parameter reference"),dr="{",pr=jn("{",!1),xr="}",br=jn("}",!1),gr=function(t){return pu("Param").merge(t)},vr=function(t){return t},Pr=Mn("identifier"),Cr=/^[a-zA-Z_]/,yr=Nn([["a","z"],["A","Z"],"_"],!1,!1),mr=/^[a-zA-Z0-9_\-]/,_r=Nn([["a","z"],["A","Z"],["0","9"],"_","-"],!1,!1),qr=function(t){return pu("Identifier").set({id:t})},Qr=Mn("quoted string literal"),Sr='"',wr=jn('"',!1),Er=/^[^"]/,Rr=Nn(['"'],!0,!1),Tr=function(t){return pu("LiteralString").set({value:t.join("")})},Fr="'",Lr=jn("'",!1),kr=/^[^']/,jr=Nn(["'"],!0,!1),Nr=Mn("escaped double-quoted-string character"),Mr="\\\\",Ur=jn("\\\\",!1),Ir=function(){return"\\"},Vr='\\"',zr=jn('\\"',!1),Dr=function(){return'"'},Zr="\\b",Or=jn("\\b",!1),Br=function(){return"\b"},$r="\\v",Gr=jn("\\v",!1),Hr=function(){return"\v"},Jr="\\f",Kr=jn("\\f",!1),Wr=function(){return"\f"},Xr="\\t",Yr=jn("\\t",!1),te=function(){return"\t"},re="\\r",ee=jn("\\r",!1),ne=function(){return"\r"},ue="\\n",se=jn("\\n",!1),ae=function(){return"\n"},oe="\\e",ce=jn("\\e",!1),ie=function(){return""},le="\\x",fe=jn("\\x",!1),he=/^[0-9a-fA-F]/,Ae=Nn([["0","9"],["a","f"],["A","F"]],!1,!1),de=function(t){return String.fromCharCode(parseInt(t,16))},pe="\\u",xe=jn("\\u",!1),be=Mn("escaped single-quoted-string character"),ge="\\'",ve=jn("\\'",!1),Pe=function(){return"'"},Ce=Mn("regular expression literal"),ye="`",me=jn("`",!1),_e="\\`",qe=jn("\\`",!1),Qe=/^[^`]/,Se=Nn(["`"],!0,!1),we=function(r){var e;try{e=new RegExp(r.replace(/\\`/g,"`"))}catch(r){!function(r,e){throw e=void 0!==e?e:In(wn,Sn),function(r,e){return new t(r,null,null,e)}(r,e)}(r.message)}return pu("LiteralRegExp").set({value:e})},Ee=Mn("numeric literal"),Re=/^[+\-]/,Te=Nn(["+","-"],!1,!1),Fe="0b",Le=jn("0b",!1),ke=/^[01]/,je=Nn(["0","1"],!1,!1),Ne=function(t,r){return pu("LiteralNumber").set({value:parseInt(t+r,2)})},Me="0o",Ue=jn("0o",!1),Ie=/^[0-7]/,Ve=Nn([["0","7"]],!1,!1),ze=function(t,r){return pu("LiteralNumber").set({value:parseInt(t+r,8)})},De="0x",Ze=jn("0x",!1),Oe=function(t,r){return pu("LiteralNumber").set({value:parseInt(t+r,16)})},Be=/^[0-9]/,$e=Nn([["0","9"]],!1,!1),Ge=".",He=jn(".",!1),Je=/^[eE]/,Ke=Nn(["e","E"],!1,!1),We=function(t){return pu("LiteralNumber").set({value:parseFloat(t)})},Xe=function(t){return pu("LiteralNumber").set({value:parseInt(t,10)})},Ye=Mn("global value"),tn="true",rn=jn("true",!1),en=function(){return pu("LiteralValue").set({value:!0})},nn="false",un=jn("false",!1),sn=function(){return pu("LiteralValue").set({value:!1})},an="null",on=jn("null",!1),cn=function(){return pu("LiteralValue").set({value:null})},ln="NaN",fn=jn("NaN",!1),hn=function(){return pu("LiteralValue").set({value:NaN})},An="undefined",dn=jn("undefined",!1),pn=function(){return pu("LiteralValue").set({value:void 0})},xn=Mn("optional blank"),bn=Mn("multi-line comment"),gn="/*",vn=jn("/*",!1),Pn="*/",Cn=jn("*/",!1),yn={type:"any"},mn=Mn("any whitespaces"),_n=/^[ \t\r\n]/,qn=Nn([" ","\t","\r","\n"],!1,!1),Qn=Mn("end of file"),Sn=0,wn=0,En=[{line:1,column:1}],Rn=0,Tn=[],Fn=0,Ln={};if("startRule"in e){if(!(e.startRule in s))throw new Error("Can't start parsing from rule \""+e.startRule+'".');a=s[e.startRule]}function kn(){return In(wn,Sn)}function jn(t,r){return{type:"literal",text:t,ignoreCase:r}}function Nn(t,r,e){return{type:"class",parts:t,inverted:r,ignoreCase:e}}function Mn(t){return{type:"other",description:t}}function Un(t){var e,n=En[t];if(n)return n;for(e=t-1;!En[e];)e--;for(n={line:(n=En[e]).line,column:n.column};e<t;)10===r.charCodeAt(e)?(n.line++,n.column=1):n.column++,e++;return En[t]=n,n}function In(t,r){var e=Un(t),n=Un(r);return{start:{offset:t,line:e.line,column:e.column},end:{offset:r,line:n.line,column:n.column}}}function Vn(t){Sn<Rn||(Sn>Rn&&(Rn=Sn,Tn=[]),Tn.push(t))}function zn(r,e,n){return new t(t.buildMessage(r,e),r,e,n)}function Dn(){var t,e,n=38*Sn+0,s=Ln[n];return s?(Sn=s.nextPos,s.result):(t=Sn,fu()!==u&&(e=function(){var t,e,n,s,a,o,f,h,A=38*Sn+1,d=Ln[A];if(d)return Sn=d.nextPos,d.result;if(t=Sn,(e=Zn())!==u){for(n=[],s=Sn,(a=fu())!==u?(44===r.charCodeAt(Sn)?(o=c,Sn++):(o=u,0===Fn&&Vn(i)),o!==u&&(f=fu())!==u&&(h=Zn())!==u?s=a=[a,o,f,h]:(Sn=s,s=u)):(Sn=s,s=u);s!==u;)n.push(s),s=Sn,(a=fu())!==u?(44===r.charCodeAt(Sn)?(o=c,Sn++):(o=u,0===Fn&&Vn(i)),o!==u&&(f=fu())!==u&&(h=Zn())!==u?s=a=[a,o,f,h]:(Sn=s,s=u)):(Sn=s,s=u);n!==u?(wn=t,e=l(e,n),t=e):(Sn=t,t=u)}else Sn=t,t=u;return Ln[A]={nextPos:Sn,result:t},t}())!==u&&fu()!==u&&function(){var t,e,n=38*Sn+37,s=Ln[n];return s?(Sn=s.nextPos,s.result):(Fn++,t=Sn,Fn++,r.length>Sn?(e=r.charAt(Sn),Sn++):(e=u,0===Fn&&Vn(yn)),Fn--,e===u?t=void 0:(Sn=t,t=u),Fn--,t===u&&(e=u,0===Fn&&Vn(Qn)),Ln[n]={nextPos:Sn,result:t},t)}()!==u?(wn=t,t=o(e)):(Sn=t,t=u),Ln[n]={nextPos:Sn,result:t},t)}function Zn(){var t,e,n,s,a,o,c=38*Sn+2,i=Ln[c];if(i)return Sn=i.nextPos,i.result;if(t=Sn,(e=function(){var t,e,n,s,a,o=38*Sn+3,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=Bn())===u&&(e=null),e!==u&&fu()!==u&&(n=$n())!==u&&fu()!==u?(33===r.charCodeAt(Sn)?(s=h,Sn++):(s=u,0===Fn&&Vn(A)),s===u&&(s=null),s!==u&&fu()!==u?((a=Gn())===u&&(a=null),a!==u?(wn=t,e=d(e,n,s,a),t=e):(Sn=t,t=u)):(Sn=t,t=u)):(Sn=t,t=u),Ln[o]={nextPos:Sn,result:t},t)}())!==u){for(n=[],s=Sn,(a=fu())!==u&&(o=On())!==u?s=a=[a,o]:(Sn=s,s=u);s!==u;)n.push(s),s=Sn,(a=fu())!==u&&(o=On())!==u?s=a=[a,o]:(Sn=s,s=u);n!==u?(wn=t,t=e=f(e,n)):(Sn=t,t=u)}else Sn=t,t=u;return Ln[c]={nextPos:Sn,result:t},t}function On(){var t,e,n,s,a,o=38*Sn+4,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=Bn())!==u&&fu()!==u&&(n=$n())!==u&&fu()!==u?(33===r.charCodeAt(Sn)?(s=h,Sn++):(s=u,0===Fn&&Vn(A)),s===u&&(s=null),s!==u&&fu()!==u?((a=Gn())===u&&(a=null),a!==u?(wn=t,t=e=d(e,n,s,a)):(Sn=t,t=u)):(Sn=t,t=u)):(Sn=t,t=u),Ln[o]={nextPos:Sn,result:t},t)}function Bn(){var t,e,n,s=38*Sn+5,a=Ln[s];return a?(Sn=a.nextPos,a.result):(Fn++,t=Sn,e=Sn,r.substr(Sn,2)===x?(n=x,Sn+=2):(n=u,0===Fn&&Vn(b)),n===u&&(47===r.charCodeAt(Sn)?(n=g,Sn++):(n=u,0===Fn&&Vn(v)),n===u&&(r.substr(Sn,3)===P?(n=P,Sn+=3):(n=u,0===Fn&&Vn(C)),n===u&&(r.substr(Sn,2)===y?(n=y,Sn+=2):(n=u,0===Fn&&Vn(m)),n===u&&(r.substr(Sn,3)===_?(n=_,Sn+=3):(n=u,0===Fn&&Vn(q)),n===u&&(r.substr(Sn,2)===Q?(n=Q,Sn+=2):(n=u,0===Fn&&Vn(S)),n===u&&(r.substr(Sn,3)===w?(n=w,Sn+=3):(n=u,0===Fn&&Vn(E)),n===u&&(r.substr(Sn,2)===R?(n=R,Sn+=2):(n=u,0===Fn&&Vn(T)),n===u&&(r.substr(Sn,4)===F?(n=F,Sn+=4):(n=u,0===Fn&&Vn(L)),n===u&&(r.substr(Sn,3)===k?(n=k,Sn+=3):(n=u,0===Fn&&Vn(j)),n===u&&(r.substr(Sn,3)===N?(n=N,Sn+=3):(n=u,0===Fn&&Vn(M)),n===u&&(r.substr(Sn,2)===U?(n=U,Sn+=2):(n=u,0===Fn&&Vn(I)),n===u&&(r.substr(Sn,3)===V?(n=V,Sn+=3):(n=u,0===Fn&&Vn(z)),n===u&&(r.substr(Sn,3)===D?(n=D,Sn+=3):(n=u,0===Fn&&Vn(Z))))))))))))))),(e=n!==u?r.substring(e,Sn):n)!==u?((n=function(){var t,e,n,s=38*Sn+6,a=Ln[s];return a?(Sn=a.nextPos,a.result):(t=Sn,58===r.charCodeAt(Sn)?(e=B,Sn++):(e=u,0===Fn&&Vn($)),e!==u&&(n=au())!==u?(wn=t,e=G(n),t=e):(Sn=t,t=u),t===u&&(t=Sn,58===r.charCodeAt(Sn)?(e=B,Sn++):(e=u,0===Fn&&Vn($)),e!==u&&(n=ou())!==u?(wn=t,e=H(n),t=e):(Sn=t,t=u)),Ln[s]={nextPos:Sn,result:t},t)}())===u&&(n=null),n!==u?(wn=t,t=e=O(e,n)):(Sn=t,t=u)):(Sn=t,t=u),Fn--,t===u&&(e=u,0===Fn&&Vn(p)),Ln[s]={nextPos:Sn,result:t},t)}function $n(){var t,e,n=38*Sn+7,s=Ln[n];return s?(Sn=s.nextPos,s.result):(t=Sn,(e=au())!==u&&(wn=t,e=J(e)),(t=e)===u&&(t=Sn,(e=ou())!==u&&(wn=t,e=K(e)),(t=e)===u&&(t=Sn,42===r.charCodeAt(Sn)?(e=W,Sn++):(e=u,0===Fn&&Vn(X)),e!==u&&(wn=t,e=Y()),t=e)),Ln[n]={nextPos:Sn,result:t},t)}function Gn(){var t,e,n,s,a=38*Sn+8,o=Ln[a];return o?(Sn=o.nextPos,o.result):(t=Sn,91===r.charCodeAt(Sn)?(e=tt,Sn++):(e=u,0===Fn&&Vn(rt)),e!==u&&fu()!==u&&(n=Hn())!==u&&fu()!==u?(93===r.charCodeAt(Sn)?(s=et,Sn++):(s=u,0===Fn&&Vn(nt)),s!==u?(wn=t,t=e=ut(n)):(Sn=t,t=u)):(Sn=t,t=u),Ln[a]={nextPos:Sn,result:t},t)}function Hn(){var t,e,n,s,a,o,c=38*Sn+9,i=Ln[c];return i?(Sn=i.nextPos,i.result):(t=Sn,(e=Jn())!==u&&fu()!==u?(r.substr(Sn,2)===st?(n=st,Sn+=2):(n=u,0===Fn&&Vn(at)),n!==u&&fu()!==u&&(s=Jn())!==u?(wn=t,t=e=ot(e,s)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=Sn,(e=Jn())!==u&&fu()!==u?(63===r.charCodeAt(Sn)?(n=ct,Sn++):(n=u,0===Fn&&Vn(it)),n!==u&&fu()!==u&&(s=Jn())!==u&&fu()!==u?(58===r.charCodeAt(Sn)?(a=B,Sn++):(a=u,0===Fn&&Vn($)),a!==u&&fu()!==u&&(o=Jn())!==u?(wn=t,t=e=lt(e,s,o)):(Sn=t,t=u)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=Jn())),Ln[c]={nextPos:Sn,result:t},t)}function Jn(){var t,e,n,s,a,o=38*Sn+10,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=Kn())!==u&&fu()!==u?(n=Sn,r.substr(Sn,2)===ft?(s=ft,Sn+=2):(s=u,0===Fn&&Vn(ht)),(n=s!==u?r.substring(n,Sn):s)!==u&&(s=fu())!==u&&(a=Jn())!==u?(wn=t,t=e=At(e,n,a)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=Kn()),Ln[o]={nextPos:Sn,result:t},t)}function Kn(){var t,e,n,s,a,o=38*Sn+11,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=Wn())!==u&&fu()!==u?(n=Sn,r.substr(Sn,2)===dt?(s=dt,Sn+=2):(s=u,0===Fn&&Vn(pt)),(n=s!==u?r.substring(n,Sn):s)!==u&&(s=fu())!==u&&(a=Kn())!==u?(wn=t,t=e=At(e,n,a)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=Wn()),Ln[o]={nextPos:Sn,result:t},t)}function Wn(){var t,e,n,s,a,o=38*Sn+12,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=Xn())!==u&&fu()!==u?(n=Sn,124===r.charCodeAt(Sn)?(s=xt,Sn++):(s=u,0===Fn&&Vn(bt)),(n=s!==u?r.substring(n,Sn):s)!==u&&(s=fu())!==u&&(a=Wn())!==u?(wn=t,t=e=gt(e,n,a)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=Xn()),Ln[o]={nextPos:Sn,result:t},t)}function Xn(){var t,e,n,s,a,o=38*Sn+13,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=Yn())!==u&&fu()!==u?(n=Sn,94===r.charCodeAt(Sn)?(s=vt,Sn++):(s=u,0===Fn&&Vn(Pt)),(n=s!==u?r.substring(n,Sn):s)!==u&&(s=fu())!==u&&(a=Xn())!==u?(wn=t,t=e=gt(e,n,a)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=Yn()),Ln[o]={nextPos:Sn,result:t},t)}function Yn(){var t,e,n,s,a,o=38*Sn+14,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=tu())!==u&&fu()!==u?(n=Sn,38===r.charCodeAt(Sn)?(s=Ct,Sn++):(s=u,0===Fn&&Vn(yt)),(n=s!==u?r.substring(n,Sn):s)!==u&&(s=fu())!==u&&(a=Yn())!==u?(wn=t,t=e=gt(e,n,a)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=tu()),Ln[o]={nextPos:Sn,result:t},t)}function tu(){var t,e,n,s,a,o=38*Sn+15,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=ru())!==u&&fu()!==u?(n=Sn,r.substr(Sn,2)===mt?(s=mt,Sn+=2):(s=u,0===Fn&&Vn(_t)),s===u&&(r.substr(Sn,2)===qt?(s=qt,Sn+=2):(s=u,0===Fn&&Vn(Qt)),s===u&&(r.substr(Sn,2)===St?(s=St,Sn+=2):(s=u,0===Fn&&Vn(wt)),s===u&&(r.substr(Sn,2)===Et?(s=Et,Sn+=2):(s=u,0===Fn&&Vn(Rt)),s===u&&(60===r.charCodeAt(Sn)?(s=Tt,Sn++):(s=u,0===Fn&&Vn(Ft)),s===u&&(62===r.charCodeAt(Sn)?(s=Lt,Sn++):(s=u,0===Fn&&Vn(kt)),s===u&&(r.substr(Sn,2)===jt?(s=jt,Sn+=2):(s=u,0===Fn&&Vn(Nt)),s===u&&(r.substr(Sn,2)===Mt?(s=Mt,Sn+=2):(s=u,0===Fn&&Vn(Ut))))))))),(n=s!==u?r.substring(n,Sn):s)!==u&&(s=fu())!==u&&(a=tu())!==u?(wn=t,t=e=It(e,n,a)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=ru()),Ln[o]={nextPos:Sn,result:t},t)}function ru(){var t,e,n,s,a,o=38*Sn+16,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=eu())!==u&&fu()!==u?(n=Sn,r.substr(Sn,2)===Vt?(s=Vt,Sn+=2):(s=u,0===Fn&&Vn(zt)),s===u&&(r.substr(Sn,2)===Dt?(s=Dt,Sn+=2):(s=u,0===Fn&&Vn(Zt))),(n=s!==u?r.substring(n,Sn):s)!==u&&(s=fu())!==u&&(a=ru())!==u?(wn=t,t=e=gt(e,n,a)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=eu()),Ln[o]={nextPos:Sn,result:t},t)}function eu(){var t,e,n,s,a,o=38*Sn+17,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=nu())!==u&&fu()!==u?(n=Sn,43===r.charCodeAt(Sn)?(s=Ot,Sn++):(s=u,0===Fn&&Vn(Bt)),s===u&&(45===r.charCodeAt(Sn)?(s=$t,Sn++):(s=u,0===Fn&&Vn(Gt))),(n=s!==u?r.substring(n,Sn):s)!==u&&(s=fu())!==u&&(a=eu())!==u?(wn=t,t=e=Ht(e,n,a)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=nu()),Ln[o]={nextPos:Sn,result:t},t)}function nu(){var t,e,n,s,a,o=38*Sn+18,c=Ln[o];return c?(Sn=c.nextPos,c.result):(t=Sn,(e=uu())!==u&&fu()!==u?(n=Sn,r.substr(Sn,2)===Jt?(s=Jt,Sn+=2):(s=u,0===Fn&&Vn(Kt)),s===u&&(42===r.charCodeAt(Sn)?(s=W,Sn++):(s=u,0===Fn&&Vn(X)),s===u&&(47===r.charCodeAt(Sn)?(s=g,Sn++):(s=u,0===Fn&&Vn(v)),s===u&&(37===r.charCodeAt(Sn)?(s=Wt,Sn++):(s=u,0===Fn&&Vn(Xt))))),(n=s!==u?r.substring(n,Sn):s)!==u&&(s=fu())!==u&&(a=nu())!==u?(wn=t,t=e=Ht(e,n,a)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=uu()),Ln[o]={nextPos:Sn,result:t},t)}function uu(){var t,e,n,s=38*Sn+19,a=Ln[s];return a?(Sn=a.nextPos,a.result):(t=Sn,e=Sn,33===r.charCodeAt(Sn)?(n=h,Sn++):(n=u,0===Fn&&Vn(A)),n===u&&(126===r.charCodeAt(Sn)?(n=Yt,Sn++):(n=u,0===Fn&&Vn(tr))),(e=n!==u?r.substring(e,Sn):n)!==u&&(n=su())!==u?(wn=t,t=e=rr(e,n)):(Sn=t,t=u),t===u&&(t=su()),Ln[s]={nextPos:Sn,result:t},t)}function su(){var t,e=38*Sn+20,n=Ln[e];return n?(Sn=n.nextPos,n.result):((t=function(){var t,e,n,s,a,o=38*Sn+21,l=Ln[o];return l?(Sn=l.nextPos,l.result):(t=Sn,(e=au())!==u&&fu()!==u?(40===r.charCodeAt(Sn)?(n=er,Sn++):(n=u,0===Fn&&Vn(nr)),n!==u&&fu()!==u?((s=function(){var t,e,n,s,a,o,l,f,h=38*Sn+22,A=Ln[h];if(A)return Sn=A.nextPos,A.result;if(t=Sn,(e=Hn())!==u){for(n=[],s=Sn,(a=fu())!==u?(44===r.charCodeAt(Sn)?(o=c,Sn++):(o=u,0===Fn&&Vn(i)),o!==u&&(l=fu())!==u&&(f=Hn())!==u?s=a=[a,o,l,f]:(Sn=s,s=u)):(Sn=s,s=u);s!==u;)n.push(s),s=Sn,(a=fu())!==u?(44===r.charCodeAt(Sn)?(o=c,Sn++):(o=u,0===Fn&&Vn(i)),o!==u&&(l=fu())!==u&&(f=Hn())!==u?s=a=[a,o,l,f]:(Sn=s,s=u)):(Sn=s,s=u);n!==u?(wn=t,e=or(e,n),t=e):(Sn=t,t=u)}else Sn=t,t=u;return Ln[h]={nextPos:Sn,result:t},t}())===u&&(s=null),s!==u&&fu()!==u?(41===r.charCodeAt(Sn)?(a=ur,Sn++):(a=u,0===Fn&&Vn(sr)),a!==u?(wn=t,e=ar(e,s),t=e):(Sn=t,t=u)):(Sn=t,t=u)):(Sn=t,t=u)):(Sn=t,t=u),Ln[o]={nextPos:Sn,result:t},t)}())===u&&(t=function(){var t,e,n,s=38*Sn+23,a=Ln[s];return a?(Sn=a.nextPos,a.result):(Fn++,t=Sn,64===r.charCodeAt(Sn)?(e=ir,Sn++):(e=u,0===Fn&&Vn(lr)),e!==u&&(n=au())!==u?(wn=t,e=fr(n),t=e):(Sn=t,t=u),t===u&&(t=Sn,64===r.charCodeAt(Sn)?(e=ir,Sn++):(e=u,0===Fn&&Vn(lr)),e!==u&&(n=ou())!==u?(wn=t,e=hr(n),t=e):(Sn=t,t=u)),Fn--,t===u&&(e=u,0===Fn&&Vn(cr)),Ln[s]={nextPos:Sn,result:t},t)}())===u&&(t=function(){var t,e,n,s,a=38*Sn+24,o=Ln[a];return o?(Sn=o.nextPos,o.result):(Fn++,t=Sn,123===r.charCodeAt(Sn)?(e=dr,Sn++):(e=u,0===Fn&&Vn(pr)),e!==u&&fu()!==u&&(n=au())!==u&&fu()!==u?(125===r.charCodeAt(Sn)?(s=xr,Sn++):(s=u,0===Fn&&Vn(br)),s!==u?(wn=t,e=gr(n),t=e):(Sn=t,t=u)):(Sn=t,t=u),Fn--,t===u&&(e=u,0===Fn&&Vn(Ar)),Ln[a]={nextPos:Sn,result:t},t)}())===u&&(t=function(){var t,e=38*Sn+25,n=Ln[e];return n?(Sn=n.nextPos,n.result):((t=ou())===u&&(t=function(){var t,e,n,s,a,o=38*Sn+31,c=Ln[o];if(c)return Sn=c.nextPos,c.result;if(Fn++,t=Sn,96===r.charCodeAt(Sn)?(e=ye,Sn++):(e=u,0===Fn&&Vn(me)),e!==u){for(n=Sn,s=[],r.substr(Sn,2)===_e?(a=_e,Sn+=2):(a=u,0===Fn&&Vn(qe)),a===u&&(Qe.test(r.charAt(Sn))?(a=r.charAt(Sn),Sn++):(a=u,0===Fn&&Vn(Se)));a!==u;)s.push(a),r.substr(Sn,2)===_e?(a=_e,Sn+=2):(a=u,0===Fn&&Vn(qe)),a===u&&(Qe.test(r.charAt(Sn))?(a=r.charAt(Sn),Sn++):(a=u,0===Fn&&Vn(Se)));(n=s!==u?r.substring(n,Sn):s)!==u?(96===r.charCodeAt(Sn)?(s=ye,Sn++):(s=u,0===Fn&&Vn(me)),s!==u?(wn=t,e=we(n),t=e):(Sn=t,t=u)):(Sn=t,t=u)}else Sn=t,t=u;return Fn--,t===u&&(e=u,0===Fn&&Vn(Ce)),Ln[o]={nextPos:Sn,result:t},t}())===u&&(t=function(){var t,e,n,s,a,o,c,i,l,f,h,A,d=38*Sn+32,p=Ln[d];if(p)return Sn=p.nextPos,p.result;if(Fn++,t=Sn,e=Sn,Re.test(r.charAt(Sn))?(n=r.charAt(Sn),Sn++):(n=u,0===Fn&&Vn(Te)),n===u&&(n=null),(e=n!==u?r.substring(e,Sn):n)!==u)if(r.substr(Sn,2)===Fe?(n=Fe,Sn+=2):(n=u,0===Fn&&Vn(Le)),n!==u){if(s=Sn,a=[],ke.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(je)),o!==u)for(;o!==u;)a.push(o),ke.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(je));else a=u;(s=a!==u?r.substring(s,Sn):a)!==u?(wn=t,e=Ne(e,s),t=e):(Sn=t,t=u)}else Sn=t,t=u;else Sn=t,t=u;if(t===u){if(t=Sn,e=Sn,Re.test(r.charAt(Sn))?(n=r.charAt(Sn),Sn++):(n=u,0===Fn&&Vn(Te)),n===u&&(n=null),(e=n!==u?r.substring(e,Sn):n)!==u)if(r.substr(Sn,2)===Me?(n=Me,Sn+=2):(n=u,0===Fn&&Vn(Ue)),n!==u){if(s=Sn,a=[],Ie.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(Ve)),o!==u)for(;o!==u;)a.push(o),Ie.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(Ve));else a=u;(s=a!==u?r.substring(s,Sn):a)!==u?(wn=t,e=ze(e,s),t=e):(Sn=t,t=u)}else Sn=t,t=u;else Sn=t,t=u;if(t===u){if(t=Sn,e=Sn,Re.test(r.charAt(Sn))?(n=r.charAt(Sn),Sn++):(n=u,0===Fn&&Vn(Te)),n===u&&(n=null),(e=n!==u?r.substring(e,Sn):n)!==u)if(r.substr(Sn,2)===De?(n=De,Sn+=2):(n=u,0===Fn&&Vn(Ze)),n!==u){if(s=Sn,a=[],he.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(Ae)),o!==u)for(;o!==u;)a.push(o),he.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(Ae));else a=u;(s=a!==u?r.substring(s,Sn):a)!==u?(wn=t,e=Oe(e,s),t=e):(Sn=t,t=u)}else Sn=t,t=u;else Sn=t,t=u;if(t===u){if(t=Sn,e=Sn,n=Sn,Re.test(r.charAt(Sn))?(s=r.charAt(Sn),Sn++):(s=u,0===Fn&&Vn(Te)),s===u&&(s=null),s!==u){for(a=[],Be.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn($e));o!==u;)a.push(o),Be.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn($e));if(a!==u)if(46===r.charCodeAt(Sn)?(o=Ge,Sn++):(o=u,0===Fn&&Vn(He)),o!==u){if(c=[],Be.test(r.charAt(Sn))?(i=r.charAt(Sn),Sn++):(i=u,0===Fn&&Vn($e)),i!==u)for(;i!==u;)c.push(i),Be.test(r.charAt(Sn))?(i=r.charAt(Sn),Sn++):(i=u,0===Fn&&Vn($e));else c=u;if(c!==u){if(i=Sn,Je.test(r.charAt(Sn))?(l=r.charAt(Sn),Sn++):(l=u,0===Fn&&Vn(Ke)),l!==u)if(Re.test(r.charAt(Sn))?(f=r.charAt(Sn),Sn++):(f=u,0===Fn&&Vn(Te)),f===u&&(f=null),f!==u){if(h=[],Be.test(r.charAt(Sn))?(A=r.charAt(Sn),Sn++):(A=u,0===Fn&&Vn($e)),A!==u)for(;A!==u;)h.push(A),Be.test(r.charAt(Sn))?(A=r.charAt(Sn),Sn++):(A=u,0===Fn&&Vn($e));else h=u;h!==u?i=l=[l,f,h]:(Sn=i,i=u)}else Sn=i,i=u;else Sn=i,i=u;i===u&&(i=null),i!==u?n=s=[s,a,o,c,i]:(Sn=n,n=u)}else Sn=n,n=u}else Sn=n,n=u;else Sn=n,n=u}else Sn=n,n=u;if((e=n!==u?r.substring(e,Sn):n)!==u&&(wn=t,e=We(e)),(t=e)===u){if(t=Sn,e=Sn,n=Sn,Re.test(r.charAt(Sn))?(s=r.charAt(Sn),Sn++):(s=u,0===Fn&&Vn(Te)),s===u&&(s=null),s!==u){if(a=[],Be.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn($e)),o!==u)for(;o!==u;)a.push(o),Be.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn($e));else a=u;a!==u?n=s=[s,a]:(Sn=n,n=u)}else Sn=n,n=u;(e=n!==u?r.substring(e,Sn):n)!==u&&(wn=t,e=Xe(e)),t=e}}}}return Fn--,t===u&&(e=u,0===Fn&&Vn(Ee)),Ln[d]={nextPos:Sn,result:t},t}())===u&&(t=lu()),Ln[e]={nextPos:Sn,result:t},t)}())===u&&(t=function(){var t,e,n,s,a=38*Sn+26,o=Ln[a];return o?(Sn=o.nextPos,o.result):(t=Sn,40===r.charCodeAt(Sn)?(e=er,Sn++):(e=u,0===Fn&&Vn(nr)),e!==u&&fu()!==u&&(n=Hn())!==u&&fu()!==u?(41===r.charCodeAt(Sn)?(s=ur,Sn++):(s=u,0===Fn&&Vn(sr)),s!==u?(wn=t,e=vr(n),t=e):(Sn=t,t=u)):(Sn=t,t=u),Ln[a]={nextPos:Sn,result:t},t)}())===u&&(t=Zn()),Ln[e]={nextPos:Sn,result:t},t)}function au(){var t,e,n,s,a,o,c,i=38*Sn+27,l=Ln[i];if(l)return Sn=l.nextPos,l.result;if(Fn++,t=Sn,e=Sn,n=Sn,s=Sn,Fn++,a=lu(),Fn--,a===u?s=void 0:(Sn=s,s=u),s!==u)if(Cr.test(r.charAt(Sn))?(a=r.charAt(Sn),Sn++):(a=u,0===Fn&&Vn(yr)),a!==u){for(o=[],mr.test(r.charAt(Sn))?(c=r.charAt(Sn),Sn++):(c=u,0===Fn&&Vn(_r));c!==u;)o.push(c),mr.test(r.charAt(Sn))?(c=r.charAt(Sn),Sn++):(c=u,0===Fn&&Vn(_r));o!==u?n=s=[s,a,o]:(Sn=n,n=u)}else Sn=n,n=u;else Sn=n,n=u;return(e=n!==u?r.substring(e,Sn):n)!==u&&(wn=t,e=qr(e)),Fn--,(t=e)===u&&(e=u,0===Fn&&Vn(Pr)),Ln[i]={nextPos:Sn,result:t},t}function ou(){var t,e,n,s,a=38*Sn+28,o=Ln[a];if(o)return Sn=o.nextPos,o.result;if(Fn++,t=Sn,34===r.charCodeAt(Sn)?(e=Sr,Sn++):(e=u,0===Fn&&Vn(wr)),e!==u){for(n=[],(s=cu())===u&&(Er.test(r.charAt(Sn))?(s=r.charAt(Sn),Sn++):(s=u,0===Fn&&Vn(Rr)));s!==u;)n.push(s),(s=cu())===u&&(Er.test(r.charAt(Sn))?(s=r.charAt(Sn),Sn++):(s=u,0===Fn&&Vn(Rr)));n!==u?(34===r.charCodeAt(Sn)?(s=Sr,Sn++):(s=u,0===Fn&&Vn(wr)),s!==u?(wn=t,t=e=Tr(n)):(Sn=t,t=u)):(Sn=t,t=u)}else Sn=t,t=u;if(t===u)if(t=Sn,39===r.charCodeAt(Sn)?(e=Fr,Sn++):(e=u,0===Fn&&Vn(Lr)),e!==u){for(n=[],(s=iu())===u&&(kr.test(r.charAt(Sn))?(s=r.charAt(Sn),Sn++):(s=u,0===Fn&&Vn(jr)));s!==u;)n.push(s),(s=iu())===u&&(kr.test(r.charAt(Sn))?(s=r.charAt(Sn),Sn++):(s=u,0===Fn&&Vn(jr)));n!==u?(39===r.charCodeAt(Sn)?(s=Fr,Sn++):(s=u,0===Fn&&Vn(Lr)),s!==u?(wn=t,t=e=Tr(n)):(Sn=t,t=u)):(Sn=t,t=u)}else Sn=t,t=u;return Fn--,t===u&&(e=u,0===Fn&&Vn(Qr)),Ln[a]={nextPos:Sn,result:t},t}function cu(){var t,e,n,s,a,o,c,i,l=38*Sn+29,f=Ln[l];return f?(Sn=f.nextPos,f.result):(Fn++,t=Sn,r.substr(Sn,2)===Mr?(e=Mr,Sn+=2):(e=u,0===Fn&&Vn(Ur)),e!==u&&(wn=t,e=Ir()),(t=e)===u&&(t=Sn,r.substr(Sn,2)===Vr?(e=Vr,Sn+=2):(e=u,0===Fn&&Vn(zr)),e!==u&&(wn=t,e=Dr()),(t=e)===u&&(t=Sn,r.substr(Sn,2)===Zr?(e=Zr,Sn+=2):(e=u,0===Fn&&Vn(Or)),e!==u&&(wn=t,e=Br()),(t=e)===u&&(t=Sn,r.substr(Sn,2)===$r?(e=$r,Sn+=2):(e=u,0===Fn&&Vn(Gr)),e!==u&&(wn=t,e=Hr()),(t=e)===u&&(t=Sn,r.substr(Sn,2)===Jr?(e=Jr,Sn+=2):(e=u,0===Fn&&Vn(Kr)),e!==u&&(wn=t,e=Wr()),(t=e)===u&&(t=Sn,r.substr(Sn,2)===Xr?(e=Xr,Sn+=2):(e=u,0===Fn&&Vn(Yr)),e!==u&&(wn=t,e=te()),(t=e)===u&&(t=Sn,r.substr(Sn,2)===re?(e=re,Sn+=2):(e=u,0===Fn&&Vn(ee)),e!==u&&(wn=t,e=ne()),(t=e)===u&&(t=Sn,r.substr(Sn,2)===ue?(e=ue,Sn+=2):(e=u,0===Fn&&Vn(se)),e!==u&&(wn=t,e=ae()),(t=e)===u&&(t=Sn,r.substr(Sn,2)===oe?(e=oe,Sn+=2):(e=u,0===Fn&&Vn(ce)),e!==u&&(wn=t,e=ie()),(t=e)===u&&(t=Sn,r.substr(Sn,2)===le?(e=le,Sn+=2):(e=u,0===Fn&&Vn(fe)),e!==u?(n=Sn,s=Sn,he.test(r.charAt(Sn))?(a=r.charAt(Sn),Sn++):(a=u,0===Fn&&Vn(Ae)),a!==u?(he.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(Ae)),o!==u?s=a=[a,o]:(Sn=s,s=u)):(Sn=s,s=u),(n=s!==u?r.substring(n,Sn):s)!==u?(wn=t,t=e=de(n)):(Sn=t,t=u)):(Sn=t,t=u),t===u&&(t=Sn,r.substr(Sn,2)===pe?(e=pe,Sn+=2):(e=u,0===Fn&&Vn(xe)),e!==u?(n=Sn,s=Sn,he.test(r.charAt(Sn))?(a=r.charAt(Sn),Sn++):(a=u,0===Fn&&Vn(Ae)),a!==u?(he.test(r.charAt(Sn))?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(Ae)),o!==u?(he.test(r.charAt(Sn))?(c=r.charAt(Sn),Sn++):(c=u,0===Fn&&Vn(Ae)),c!==u?(he.test(r.charAt(Sn))?(i=r.charAt(Sn),Sn++):(i=u,0===Fn&&Vn(Ae)),i!==u?s=a=[a,o,c,i]:(Sn=s,s=u)):(Sn=s,s=u)):(Sn=s,s=u)):(Sn=s,s=u),(n=s!==u?r.substring(n,Sn):s)!==u?(wn=t,t=e=de(n)):(Sn=t,t=u)):(Sn=t,t=u))))))))))),Fn--,t===u&&(e=u,0===Fn&&Vn(Nr)),Ln[l]={nextPos:Sn,result:t},t)}function iu(){var t,e,n=38*Sn+30,s=Ln[n];return s?(Sn=s.nextPos,s.result):(Fn++,t=Sn,r.substr(Sn,2)===ge?(e=ge,Sn+=2):(e=u,0===Fn&&Vn(ve)),e!==u&&(wn=t,e=Pe()),Fn--,(t=e)===u&&(e=u,0===Fn&&Vn(be)),Ln[n]={nextPos:Sn,result:t},t)}function lu(){var t,e,n=38*Sn+33,s=Ln[n];return s?(Sn=s.nextPos,s.result):(Fn++,t=Sn,r.substr(Sn,4)===tn?(e=tn,Sn+=4):(e=u,0===Fn&&Vn(rn)),e!==u&&(wn=t,e=en()),(t=e)===u&&(t=Sn,r.substr(Sn,5)===nn?(e=nn,Sn+=5):(e=u,0===Fn&&Vn(un)),e!==u&&(wn=t,e=sn()),(t=e)===u&&(t=Sn,r.substr(Sn,4)===an?(e=an,Sn+=4):(e=u,0===Fn&&Vn(on)),e!==u&&(wn=t,e=cn()),(t=e)===u&&(t=Sn,r.substr(Sn,3)===ln?(e=ln,Sn+=3):(e=u,0===Fn&&Vn(fn)),e!==u&&(wn=t,e=hn()),(t=e)===u&&(t=Sn,r.substr(Sn,9)===An?(e=An,Sn+=9):(e=u,0===Fn&&Vn(dn)),e!==u&&(wn=t,e=pn()),t=e)))),Fn--,t===u&&(e=u,0===Fn&&Vn(Ye)),Ln[n]={nextPos:Sn,result:t},t)}function fu(){var t,r,e=38*Sn+34,n=Ln[e];if(n)return Sn=n.nextPos,n.result;for(Fn++,t=[],(r=hu())===u&&(r=Au());r!==u;)t.push(r),(r=hu())===u&&(r=Au());return Fn--,t===u&&(r=u,0===Fn&&Vn(xn)),Ln[e]={nextPos:Sn,result:t},t}function hu(){var t,e,n,s,a,o,c=38*Sn+35,i=Ln[c];if(i)return Sn=i.nextPos,i.result;if(Fn++,t=Sn,r.substr(Sn,2)===gn?(e=gn,Sn+=2):(e=u,0===Fn&&Vn(vn)),e!==u){for(n=[],s=Sn,a=Sn,Fn++,r.substr(Sn,2)===Pn?(o=Pn,Sn+=2):(o=u,0===Fn&&Vn(Cn)),Fn--,o===u?a=void 0:(Sn=a,a=u),a!==u?(r.length>Sn?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(yn)),o!==u?s=a=[a,o]:(Sn=s,s=u)):(Sn=s,s=u);s!==u;)n.push(s),s=Sn,a=Sn,Fn++,r.substr(Sn,2)===Pn?(o=Pn,Sn+=2):(o=u,0===Fn&&Vn(Cn)),Fn--,o===u?a=void 0:(Sn=a,a=u),a!==u?(r.length>Sn?(o=r.charAt(Sn),Sn++):(o=u,0===Fn&&Vn(yn)),o!==u?s=a=[a,o]:(Sn=s,s=u)):(Sn=s,s=u);n!==u?(r.substr(Sn,2)===Pn?(s=Pn,Sn+=2):(s=u,0===Fn&&Vn(Cn)),s!==u?t=e=[e,n,s]:(Sn=t,t=u)):(Sn=t,t=u)}else Sn=t,t=u;return Fn--,t===u&&(e=u,0===Fn&&Vn(bn)),Ln[c]={nextPos:Sn,result:t},t}function Au(){var t,e,n=38*Sn+36,s=Ln[n];if(s)return Sn=s.nextPos,s.result;if(Fn++,t=[],_n.test(r.charAt(Sn))?(e=r.charAt(Sn),Sn++):(e=u,0===Fn&&Vn(qn)),e!==u)for(;e!==u;)t.push(e),_n.test(r.charAt(Sn))?(e=r.charAt(Sn),Sn++):(e=u,0===Fn&&Vn(qn));else t=u;return Fn--,t===u&&(e=u,0===Fn&&Vn(mn)),Ln[n]={nextPos:Sn,result:t},t}var du=e.util.makeUnroll(kn,e),pu=e.util.makeAST(kn,e);if((n=a())!==u&&Sn===r.length)return n;throw n!==u&&Sn<r.length&&Vn({type:"end"}),zn(Tn,Rn<r.length?r.charAt(Rn):null,Rn<r.length?In(Rn,Rn+1):In(Rn,Rn))}}}(),ASTQQuery=function(){function t(r){_classCallCheck(this,t),this.asty=new _asty2.default,this.ast=null,r&&this.compile(r)}return _createClass(t,[{key:"compile",value:function(t,r){var e=this;r&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\nASTQ: compile: | "+t);var n=_pegjsUtil2.default.parse(ASTQQueryParse,t,{startRule:"query",makeAST:function(t,r,n,u){return e.asty.create.apply(e.asty,u).pos(t,r,n)}});if(null!==n.error)throw new Error("ASTQ: compile: query parsing failed:\n"+_pegjsUtil2.default.errorMessage(n.error,!0).replace(/^/gm,"ERROR: "));return this.ast=n.ast,r&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\n"+this.dump().replace(/\n$/,"").replace(/^/gm,"ASTQ: compile: | ")),this}},{key:"dump",value:function(){return this.ast.dump()}},{key:"execute",value:function(t,r,e,n,u){return u&&console.log("ASTQ: execute: +--------------------------------------------------------------+----------------------------------------"),new _astqQueryExec2.default(r,e,n,u).execQuery(this.ast,t)}}]),t}();exports.default=ASTQQuery;
},{"./astq-query-exec.js":12,"asty":1,"pegjs-util":3}],15:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_createClass=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var ASTQUtil=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"pad",value:function(e,t){var n=t<0?-t:t;if(e.length>n)e=e.substr(0,n);else{var r=Array(n+1-e.length).join(" ");e=t<0?e+r:r+e}return e}},{key:"truthy",value:function(e){var t=void 0;switch(void 0===e?"undefined":_typeof(e)){case"boolean":t=e;break;case"number":t=0!==e&&!isNaN(e);break;case"string":t=""!==e;break;case"object":t=!1,null!==e&&(t=!0,e instanceof Array&&(t=e.length>0));break;default:t=!1}return t}},{key:"coerce",value:function(e,t){if((void 0===e?"undefined":_typeof(e))!==t)try{switch(t){case"boolean":"boolean"!=typeof e&&(e=Boolean(e));break;case"number":"number"!=typeof e&&(e=Number(e));break;case"string":"string"!=typeof e&&(e=String(e));break;case"regexp":"object"===(void 0===e?"undefined":_typeof(e))&&e instanceof RegExp||(e=new RegExp(e))}}catch(e){throw new Error("cannot coerce value into type "+t)}return e}}]),e}();exports.default=ASTQUtil;
},{}],16:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var version={major:2,minor:3,micro:3,date:20180623};exports.default=version;
},{}],17:[function(_dereq_,module,exports){
"use strict";var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}return function(t,r,a){return r&&e(t.prototype,r),a&&e(t,a),t}}(),_cacheLru=_dereq_("cache-lru"),_cacheLru2=_interopRequireDefault(_cacheLru),_astqAdapter=_dereq_("./astq-adapter.js"),_astqAdapter2=_interopRequireDefault(_astqAdapter),_astqAdapterXmldom=_dereq_("./astq-adapter-xmldom.js"),_astqAdapterXmldom2=_interopRequireDefault(_astqAdapterXmldom),_astqAdapterParse=_dereq_("./astq-adapter-parse5.js"),_astqAdapterParse2=_interopRequireDefault(_astqAdapterParse),_astqAdapterMozast=_dereq_("./astq-adapter-mozast.js"),_astqAdapterMozast2=_interopRequireDefault(_astqAdapterMozast),_astqAdapterGraphql=_dereq_("./astq-adapter-graphql.js"),_astqAdapterGraphql2=_interopRequireDefault(_astqAdapterGraphql),_astqAdapterAsty=_dereq_("./astq-adapter-asty.js"),_astqAdapterAsty2=_interopRequireDefault(_astqAdapterAsty),_astqFuncs=_dereq_("./astq-funcs.js"),_astqFuncs2=_interopRequireDefault(_astqFuncs),_astqFuncsStd=_dereq_("./astq-funcs-std.js"),_astqFuncsStd2=_interopRequireDefault(_astqFuncsStd),_astqQuery=_dereq_("./astq-query.js"),_astqQuery2=_interopRequireDefault(_astqQuery),_astqVersion=_dereq_("./astq-version.js"),_astqVersion2=_interopRequireDefault(_astqVersion);function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var ASTQ=function(){function e(){for(var t in _classCallCheck(this,e),this._adapter=(new _astqAdapter2.default).register(_astqAdapterXmldom2.default,!1).register(_astqAdapterParse2.default,!1).register(_astqAdapterMozast2.default,!1).register(_astqAdapterGraphql2.default,!1).register(_astqAdapterAsty2.default,!1),this._funcs=new _astqFuncs2.default,_astqFuncsStd2.default)this.func(t,_astqFuncsStd2.default[t]);this._cache=new _cacheLru2.default}return _createClass(e,[{key:"version",value:function(){return _astqVersion2.default}},{key:"adapter",value:function(e){var t=this,r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(arguments.length<1||arguments.length>2)throw new Error("ASTQ#adapter: invalid number of arguments");if(this._adapter.unregister(),"object"===(void 0===e?"undefined":_typeof(e))&&e instanceof Array||(e=[e]),e.length>1&&r)throw new Error("ASTQ#adapter: you can force just a single adapter to not taste the AST node");return e.forEach(function(e){if("string"==typeof e)if("mozast"===e)e=_astqAdapterMozast2.default;else if("graphql"===e)e=_astqAdapterGraphql2.default;else if("xmldom"===e)e=_astqAdapterXmldom2.default;else if("parse5"===e)e=_astqAdapterParse2.default;else{if("asty"!==e)throw new Error("ASTQ#adapter: unknown built-in adapter");e=_astqAdapterAsty2.default}t._adapter.register(e,r)}),this}},{key:"func",value:function(e,t){if(2!==arguments.length)throw new Error("ASTQ#func: invalid number of arguments");return this._funcs.register(e,t),this}},{key:"cache",value:function(e){if(1!==arguments.length)throw new Error("ASTQ#cache: invalid number of arguments");return this._cache.limit(e),this}},{key:"compile",value:function(e,t){if(arguments.length<1)throw new Error("ASTQ#compile: too less arguments");if(arguments.length>2)throw new Error("ASTQ#compile: too many arguments");void 0===t&&(t=!1);var r=this._cache.get(e);return void 0===r&&((r=new _astqQuery2.default).compile(e,t),this._cache.set(e,r)),r}},{key:"execute",value:function(e,t,r,a){if(arguments.length<2)throw new Error("ASTQ#execute: too less arguments");if(arguments.length>4)throw new Error("ASTQ#execute: too many arguments");void 0===r&&(r={}),void 0===a&&(a=!1);var s=this._adapter.select(e);if(void 0===s)throw new Error("ASTQ#execute: no suitable adapter found for node");return t.execute(e,s,r,this._funcs,a)}},{key:"query",value:function(e,t,r,a){if(arguments.length<2)throw new Error("ASTQ#query: too less arguments");if(arguments.length>4)throw new Error("ASTQ#query: too many arguments");return void 0===r&&(r={}),void 0===a&&(a=!1),this.execute(e,this.compile(t,a),r,a)}}]),e}();module.exports=ASTQ;
},{"./astq-adapter-asty.js":4,"./astq-adapter-graphql.js":5,"./astq-adapter-mozast.js":6,"./astq-adapter-parse5.js":7,"./astq-adapter-xmldom.js":8,"./astq-adapter.js":9,"./astq-funcs-std.js":10,"./astq-funcs.js":11,"./astq-query.js":14,"./astq-version.js":16,"cache-lru":2}]},{},[4,5,6,7,8,9,10,11,12,13,14,15,16,17])(17)
});
